import { r as registerInstance, h } from './core-db63ec26.js';
var keys = ['inputs', 'outputs', 'props', 'events', 'methods'];
var Api = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
    }
    class_1.prototype.hasApi = function () {
        if (!this.doc) {
            return false;
        }
        for (var _i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
            var k = keys_1[_i];
            if (this.doc[k] && this.doc[k].length > 0) {
                return true;
            }
        }
    };
    class_1.prototype.angular = function () {
        return [
            this.doc.inputs ? this.doc.inputs.map(function (i) { return h("ad-input-def", { input: i }); }) : undefined,
            this.doc.outputs ? this.doc.outputs.map(function (i) { return h("ad-output-def", { output: i }); }) : undefined,
            this.doc.props ? this.doc.props.map(function (i) { return h("ad-prop-def", { prop: i }); }) : undefined
        ];
    };
    class_1.prototype.stencil = function () {
        return [
            this.doc.props ? this.doc.props.map(function (i) { return h("ad-prop-def", { prop: i }); }) : undefined,
            this.doc.events ? this.doc.events.map(function (i) { return h("ad-event-def", { event: i }); }) : undefined,
        ];
    };
    class_1.prototype.render = function () {
        if (!this.hasApi()) {
            return undefined;
        }
        var isAngular = !this.doc.tag;
        return (h("article", { id: "api", class: "api" }, h("h2", null, "API"), isAngular ? this.angular() : this.stencil(), this.doc.methods ? this.doc.methods.map(function (i) { return h("ad-method-def", { method: i }); }) : undefined));
    };
    Object.defineProperty(class_1, "style", {
        get: function () { return ".sc-ad-api-h{display:block;font-size:.875rem;font-family:var(--anj-font-family);font-weight:400;line-height:1.5;outline:none}.sc-ad-api-h, .sc-ad-api-h:after, .sc-ad-api-h:before{-webkit-box-sizing:border-box;box-sizing:border-box;outline:none}.sc-ad-api-h:active, .sc-ad-api-h .sc-ad-api:active, .sc-ad-api-h:focus, .sc-ad-api-h .sc-ad-api:focus{outline:none}.sc-ad-api-h .api.sc-ad-api{border-bottom:1px solid var(--anj-border);margin-bottom:3rem;padding-bottom:3rem}.sc-ad-api-h .api.sc-ad-api h2.sc-ad-api{margin-bottom:1.5rem}"; },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
var ApiName = /** @class */ (function () {
    function class_2(hostRef) {
        registerInstance(this, hostRef);
    }
    Object.defineProperty(class_2, "style", {
        get: function () { return "ad-api-name{display:inline;font-size:.875rem;font-family:var(--anj-font-family);font-weight:400;line-height:1.5;outline:none}ad-api-name,ad-api-name:after,ad-api-name:before{-webkit-box-sizing:border-box;box-sizing:border-box;outline:none}ad-api-name:active,ad-api-name :active,ad-api-name:focus,ad-api-name :focus{outline:none}ad-api-name:after{color:var(--anj-secondary-dark);content:\":\";margin-right:.5rem}"; },
        enumerable: true,
        configurable: true
    });
    return class_2;
}());
var ArgDef = /** @class */ (function () {
    function class_3(hostRef) {
        registerInstance(this, hostRef);
    }
    class_3.prototype.render = function () {
        return [
            h("ad-api-name", null, this.arg.name),
            h("ad-type-def", null, this.arg.type)
        ];
    };
    Object.defineProperty(class_3, "style", {
        get: function () { return "ad-arg-def{display:inline;font-size:.875rem;font-family:var(--anj-font-family);font-weight:400;line-height:1.5;outline:none}ad-arg-def,ad-arg-def:after,ad-arg-def:before{-webkit-box-sizing:border-box;box-sizing:border-box;outline:none}ad-arg-def:active,ad-arg-def :active,ad-arg-def:focus,ad-arg-def :focus{outline:none}ad-arg-def:after{color:var(--anj-secondary-dark);content:\",\";margin-right:.5rem}ad-arg-def:last-child:after{content:none;margin-right:0}"; },
        enumerable: true,
        configurable: true
    });
    return class_3;
}());
var Decorator = /** @class */ (function () {
    function class_4(hostRef) {
        registerInstance(this, hostRef);
    }
    Object.defineProperty(class_4, "style", {
        get: function () { return "ad-decorator{color:var(--anj-secondary-dark)}.api.ng ad-method-def ad-decorator,.api.ng ad-prop-def ad-decorator{display:none}"; },
        enumerable: true,
        configurable: true
    });
    return class_4;
}());
var EventDef = /** @class */ (function () {
    function class_5(hostRef) {
        registerInstance(this, hostRef);
    }
    class_5.prototype.render = function () {
        return [
            h("h4", null, h("ad-decorator", null, "@Event"), "\u00A0", h("ad-api-name", null, this.event.event), h("ad-type-def", null, "<", this.event.detail, ">")),
            h("p", null, this.event.docs)
        ];
    };
    Object.defineProperty(class_5, "style", {
        get: function () { return "ad-event-def,ad-input-def,ad-method-def,ad-output-def,ad-prop-def{display:block;margin-bottom:1.5rem}ad-event-def h4,ad-input-def h4,ad-method-def h4,ad-output-def h4,ad-prop-def h4{color:var(--anj-dark);font-size:1rem;font-weight:400;margin:0 0 .5rem;padding:0}"; },
        enumerable: true,
        configurable: true
    });
    return class_5;
}());
var InputDef = /** @class */ (function () {
    function class_6(hostRef) {
        registerInstance(this, hostRef);
    }
    class_6.prototype.render = function () {
        return [
            h("h4", null, h("ad-decorator", null, "@Input\u00A0"), h("ad-api-name", null, this.input.name), h("ad-type-def", null, this.input.type)),
            h("p", null, this.input.docs)
        ];
    };
    Object.defineProperty(class_6, "style", {
        get: function () { return "ad-event-def,ad-input-def,ad-method-def,ad-output-def,ad-prop-def{display:block;margin-bottom:1.5rem}ad-event-def h4,ad-input-def h4,ad-method-def h4,ad-output-def h4,ad-prop-def h4{color:var(--anj-dark);font-size:1rem;font-weight:400;margin:0 0 .5rem;padding:0}"; },
        enumerable: true,
        configurable: true
    });
    return class_6;
}());
var MethodDef = /** @class */ (function () {
    function class_7(hostRef) {
        registerInstance(this, hostRef);
    }
    class_7.prototype.nameless = function (name) {
        return "(" + name.split('(')[1];
    };
    class_7.prototype.render = function () {
        return [
            h("h4", null, h("ad-decorator", null, "@Method\u00A0"), h("ad-api-name", null, this.method.name), h("ad-type-def", null, this.nameless(this.method.signature))),
            h("p", null, this.method.docs)
        ];
    };
    Object.defineProperty(class_7, "style", {
        get: function () { return "ad-event-def,ad-input-def,ad-method-def,ad-output-def,ad-prop-def{display:block;margin-bottom:1.5rem}ad-event-def h4,ad-input-def h4,ad-method-def h4,ad-output-def h4,ad-prop-def h4{color:var(--anj-dark);font-size:1rem;font-weight:400;margin:0 0 .5rem;padding:0}"; },
        enumerable: true,
        configurable: true
    });
    return class_7;
}());
var OutputDef = /** @class */ (function () {
    function class_8(hostRef) {
        registerInstance(this, hostRef);
    }
    class_8.prototype.render = function () {
        return [
            h("h4", null, h("ad-decorator", null, "@Output\u00A0"), h("ad-api-name", null, this.output.name), h("ad-type-def", null, this.output.type)),
            h("p", null, this.output.docs)
        ];
    };
    Object.defineProperty(class_8, "style", {
        get: function () { return "ad-event-def,ad-input-def,ad-method-def,ad-output-def,ad-prop-def{display:block;margin-bottom:1.5rem}ad-event-def h4,ad-input-def h4,ad-method-def h4,ad-output-def h4,ad-prop-def h4{color:var(--anj-dark);font-size:1rem;font-weight:400;margin:0 0 .5rem;padding:0}"; },
        enumerable: true,
        configurable: true
    });
    return class_8;
}());
var PropDef = /** @class */ (function () {
    function class_9(hostRef) {
        registerInstance(this, hostRef);
    }
    class_9.prototype.render = function () {
        return [
            h("h4", null, h("ad-decorator", null, "@Prop\u00A0"), h("ad-api-name", null, this.prop.name), h("ad-type-def", null, this.prop.type)),
            h("p", null, this.prop.docs)
        ];
    };
    Object.defineProperty(class_9, "style", {
        get: function () { return "ad-event-def,ad-input-def,ad-method-def,ad-output-def,ad-prop-def{display:block;margin-bottom:1.5rem}ad-event-def h4,ad-input-def h4,ad-method-def h4,ad-output-def h4,ad-prop-def h4{color:var(--anj-dark);font-size:1rem;font-weight:400;margin:0 0 .5rem;padding:0}"; },
        enumerable: true,
        configurable: true
    });
    return class_9;
}());
var RealTime = /** @class */ (function () {
    function class_10(hostRef) {
        registerInstance(this, hostRef);
    }
    Object.defineProperty(class_10, "style", {
        get: function () { return "ad-real-time{border:1px dashed var(--anj-border);border-radius:.25rem;display:block;margin-top:1.5rem;overflow-x:auto;padding:1rem;width:100%}"; },
        enumerable: true,
        configurable: true
    });
    return class_10;
}());
var Toc = /** @class */ (function () {
    function class_11(hostRef) {
        registerInstance(this, hostRef);
        this.activeId = '#overview';
        /**
         * The object map of usa cases to their markdown
         */
        this.docs = {};
        /**
         * The object map of usa cases to their markdown
         */
        this.keys = [];
    }
    class_11.prototype.onDemosChange = function () {
        this.sectionIds = ['#overview'].concat(this.keys.map(function (d) { return "#" + d; })).concat('#api');
    };
    class_11.prototype.connectedCallback = function () {
        this.navigate = debounce(this.navigate.bind(this), 100);
        this.onScroll = debounce(this.onScroll.bind(this), 25);
        this.onDemosChange();
        if (window.location.hash) {
            this.navigate();
        }
    };
    class_11.prototype.onScroll = function () {
        var els = this.sectionIds.map(function (id) { return document.querySelector(id); });
        var closest = els[0];
        els.slice(1).forEach(function (el) {
            if (el && Math.abs(window.scrollY - el.offsetTop) < Math.abs(window.scrollY - closest.offsetTop)) {
                closest = el;
            }
        });
        this.activeId = "#" + closest.getAttribute('id');
    };
    class_11.prototype.parseTitle = function (id) {
        var usage = id.replace('#', '');
        var doc = this.docs[usage];
        return doc ? doc.split(/##(.*?)\n/).find(function (p) { return p !== ''; }).trim() : usage;
    };
    class_11.prototype.anchorClass = function (usage) {
        return usage === this.activeId ? 'anj-active' : '';
    };
    class_11.prototype.navigate = function () {
        var _this = this;
        return new Promise(function (resolve) {
            window.setTimeout(function () {
                _this.activeId = window.location.hash;
                var el = document.querySelector(_this.activeId);
                if (el) {
                    window.scrollTo(0, el.offsetTop);
                }
                resolve();
            }, 500);
        });
    };
    class_11.prototype.render = function () {
        var _this = this;
        if (!this.sectionIds) {
            return;
        }
        var path = window.location.pathname;
        return (h("div", { class: "anj-toc" }, this.sectionIds.map(function (id) { return h("a", { href: "" + path + id, onClick: function () { return _this.activeId = id; }, class: _this.anchorClass(id) }, _this.parseTitle(id)); })));
    };
    Object.defineProperty(class_11, "watchers", {
        get: function () {
            return {
                "keys": ["onDemosChange"]
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(class_11, "style", {
        get: function () { return "ad-toc{display:block;position:relative}ad-toc .anj-toc{padding:1rem 0;position:fixed;top:3rem}ad-toc a{display:block;font-size:.75rem;margin-bottom:.5rem;text-transform:capitalize;-webkit-transition:color .2s ease;transition:color .2s ease}ad-toc a:focus{text-decoration:underline}ad-toc a:active{text-decoration:none}ad-toc a.anj-active,ad-toc a.anj-active:focus,ad-toc a.anj-active:hover{color:var(--anj-primary);text-decoration:none}"; },
        enumerable: true,
        configurable: true
    });
    return class_11;
}());
var debounce = function (func, wait) {
    if (wait === void 0) { wait = 0; }
    var timer;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        clearTimeout(timer);
        timer = setTimeout.apply(void 0, [func, wait].concat(args));
    };
};
var TypeDef = /** @class */ (function () {
    function class_12(hostRef) {
        registerInstance(this, hostRef);
    }
    Object.defineProperty(class_12, "style", {
        get: function () { return "ad-type-def{color:var(--anj-neutral-dark);font-size:.75rem}"; },
        enumerable: true,
        configurable: true
    });
    return class_12;
}());
export { Api as ad_api, ApiName as ad_api_name, ArgDef as ad_arg_def, Decorator as ad_decorator, EventDef as ad_event_def, InputDef as ad_input_def, MethodDef as ad_method_def, OutputDef as ad_output_def, PropDef as ad_prop_def, RealTime as ad_real_time, Toc as ad_toc, TypeDef as ad_type_def };
